/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 22:38:53 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.civicinfo.model;

/**
 * The list of elections available for this version of the API.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Civic Information API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ElectionsQueryResponse extends com.google.api.client.json.GenericJson {

  /**
   * A list of available elections
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Election> elections;

  /**
   * The kind, fixed to "civicinfo#electionsQueryResponse".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * A list of available elections
   * @return value or {@code null} for none
   */
  public java.util.List<Election> getElections() {
    return elections;
  }

  /**
   * A list of available elections
   * @param elections elections or {@code null} for none
   */
  public ElectionsQueryResponse setElections(java.util.List<Election> elections) {
    this.elections = elections;
    return this;
  }

  /**
   * The kind, fixed to "civicinfo#electionsQueryResponse".
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The kind, fixed to "civicinfo#electionsQueryResponse".
   * @param kind kind or {@code null} for none
   */
  public ElectionsQueryResponse setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  @Override
  public ElectionsQueryResponse set(String fieldName, Object value) {
    return (ElectionsQueryResponse) super.set(fieldName, value);
  }

  @Override
  public ElectionsQueryResponse clone() {
    return (ElectionsQueryResponse) super.clone();
  }

}
